#include <Engine/types/entity/InstancedSprite.h>
#include <Engine/Globals.h>

using namespace Engine;
Texture* InstancedSprite::GetTexture() {
    return Globals::CurrentScene->GetInstancedTexture(this)->GetTexture();
}

Texture* InstancedSprite::GetAlphaMask() {
    if (Sprite::GetAlphaMask())
        return Sprite::GetAlphaMask();
    return Globals::CurrentScene->GetInstancedAlphaMask(this)->GetTexture();
}

InstancedSprite::~InstancedSprite() {
    auto* itx = Globals::CurrentScene->GetInstancedTexture(this);
    if (itx) {
        itx->RemoveUser(this);
        if (itx->ReferenceCount() == 0)
            Globals::CurrentScene->DestroyInstancedTexture(itx);
    }

    auto* ita = Globals::CurrentScene->GetInstancedAlphaMask(this);
    if (ita) {
        ita->RemoveUser(this);
        if (ita->ReferenceCount() == 0)
            Globals::CurrentScene->DestroyInstancedAlphaMask(ita);
    }
}
